import pygame
import time
import random

# объявляем переменные
FPS = 60
width_field=800 # размер поля по ширине
height_field=600 # размер поля по высоте
size_x=20   # количество клеток по ширине
size_y=20   # количество клеток по высоте
color_grid=(0,200,100)  # цвет линий ячеек
fill_grid=(0,0,0)       # цвет игровогого поля
color_python=(50,200,100) # цвет тела питона
step_x=round(width_field/size_x,0)  # шаг клетки по ширине
step_y=round(height_field/size_y,0) # шаг клетки по высоте
python_body=[[round(size_x/2,0),round(size_y/2,0)],[round((size_x-2)/2,0),round(size_y/2,0)],[round((size_x-4)/2,0),round(size_y/2,0)]] # массив тела питона
moved_direction_x=0 # текущее направление движения питона по оси x
moved_direction_y=0 # текущее направление движения питона по оси y
foods=[]    # массив координат с едой
max_foods=3 # сколько еды может быть одновременно на поле
color_food=[(100,200,150),(200,100,150),(140,20,150)]
# Генерируем и отрисовываем еду для питона
def Draw_foods(screen):
    for i in range(max_foods-len(foods)): # массив с едой всегда должен быть "полон"
        while True: # цикл генерации еды. Генерируем до тех пор пока сгенерированные координаты не устроят нас
            x=random.randint(0,size_x)+1
            y=random.randint(0,size_y)+1
            food_type = random.randint(0, len(color_food) - 1)
            if [x,y] not in python_body:
                break;
        foods.insert(0,[x,y,food_type])
    print(f"Нагенерировали еды: {foods}, теперь её нарисуем");
    for element in foods:
        coors=[element[0]*step_x-step_x/2,element[1]*step_y-step_y/2]
        pygame.draw.circle(screen,color_food[element[2]],coors,radius/2)

def Draw_grid_field(screen):
 xx=0;
 for x in range(size_x):
   pygame.draw.line(screen,color_grid,(xx,0),(xx,height_field))
   xx=xx+step_x;
 yy=0;
 for y in range(size_y):
   pygame.draw.line(screen,color_grid,(0,yy),(width_field,yy))
   yy=yy+step_y;
# рисуем питона
def Draw_python(screen):
    if moved_direction_x!=0 or moved_direction_y!=0:
        print(f"Пришли:{python_body}")
        head_coor = python_body[0].copy()
        head_coor[0] = head_coor[0] + moved_direction_x;
        head_coor[1] = head_coor[1] + moved_direction_y;
        print(f"-тело{python_body},голова: {head_coor}");
        python_body.insert(0, head_coor) # передвигаю голову
        print(f"Передвинули голову:{python_body}")

        #проверяем: если голова совпадает с какойто едой, то еду удаляем, а жопу не удяляем
        del_tail = True
        for element in foods:
            if [element[0],element[1]] == head_coor:
                del_tail=False
                foods.remove(element)

        if del_tail==True:
            # зарисовываю черным жопу
            element=python_body[len(python_body) - 1]
            coors=[element[0]*step_x-step_x/2,element[1]*step_y-step_y/2]
            pygame.draw.circle(screen,(0,0,0),coors,radius)
            # удаляю последний элемент хвоста
            python_body.pop(-1)
            print(f"удалили жопу:{python_body}")

    # рисую тушку
    for element in python_body:
        coors=[element[0]*step_x-step_x/2,element[1]*step_y-step_y/2]
        pygame.draw.circle(screen,color_python,coors,radius)


print("###############################################")
print(f"# Размер поля: w={size_x},y={size_y}")
print(f"# Размер ячеек: w={step_x},y={step_y}")
print(f"# Тело питона: {python_body}")
print("###############################################")

pygame.init()
clock = pygame.time.Clock()
screen = pygame.display.set_mode((width_field, height_field))
screen.fill(fill_grid)
Draw_grid_field(screen)
start_time=time.time()
radius = (round(step_x / 2) - 1) if round(step_x / 2) < round(step_y / 2) else (round(step_y / 2) - 1)  # выбираем радиус по ширине или высоте шага, смотря что меньше, чтоб вписаться в прямоугольник
running = True
while running:
    if (time.time()-start_time)>1:
        start_time=time.time()
        Draw_foods(screen)
        Draw_python(screen)
    for event in pygame.event.get():
        if event.type == pygame.KEYDOWN:
            if event.key == pygame.K_LEFT:
                moved_direction_x=-1
                moved_direction_y=0
            if event.key == pygame.K_RIGHT:
                moved_direction_x = 1
                moved_direction_y = 0
            if event.key == pygame.K_UP:
                moved_direction_y = -1
                moved_direction_x=0
            if event.key == pygame.K_DOWN:
                moved_direction_x=0
                moved_direction_y = 1
        if event.type == pygame.QUIT:
           running = False
    pygame.display.flip()
    pygame.display.update()
    clock.tick(FPS)
pygame.quit()
print("нормально вышли")